/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleBigQueryDto type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleBigQueryDto{}

// GoogleBigQueryDto struct for GoogleBigQueryDto
type GoogleBigQueryDto struct {
	ConnectorId *string                         `json:"connectorId,omitempty"`
	TemplateId  *string                         `json:"templateId,omitempty"`
	Label       *string                         `json:"label,omitempty"`
	Strategy    *string                         `json:"strategy,omitempty"`
	Request     NullableHttpConnectorDtoRequest `json:"request,omitempty"`
	OAuthId     *int32                          `json:"o_auth_id,omitempty"`
	ProjectId   *int32                          `json:"projectId,omitempty"`
	DatasetId   *string                         `json:"datasetId,omitempty"`
	TableId     *string                         `json:"tableId,omitempty"`
	Statement   *string                         `json:"statement,omitempty"`
}

// NewGoogleBigQueryDto instantiates a new GoogleBigQueryDto object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleBigQueryDto() *GoogleBigQueryDto {
	this := GoogleBigQueryDto{}
	return &this
}

// NewGoogleBigQueryDtoWithDefaults instantiates a new GoogleBigQueryDto object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleBigQueryDtoWithDefaults() *GoogleBigQueryDto {
	this := GoogleBigQueryDto{}
	return &this
}

// GetConnectorId returns the ConnectorId field value if set, zero value otherwise.
func (o *GoogleBigQueryDto) GetConnectorId() string {
	if o == nil || IsNil(o.ConnectorId) {
		var ret string
		return ret
	}
	return *o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDto) GetConnectorIdOk() (*string, bool) {
	if o == nil || IsNil(o.ConnectorId) {
		return nil, false
	}
	return o.ConnectorId, true
}

// HasConnectorId returns a boolean if a field has been set.
func (o *GoogleBigQueryDto) HasConnectorId() bool {
	if o != nil && !IsNil(o.ConnectorId) {
		return true
	}

	return false
}

// SetConnectorId gets a reference to the given string and assigns it to the ConnectorId field.
func (o *GoogleBigQueryDto) SetConnectorId(v string) {
	o.ConnectorId = &v
}

// GetTemplateId returns the TemplateId field value if set, zero value otherwise.
func (o *GoogleBigQueryDto) GetTemplateId() string {
	if o == nil || IsNil(o.TemplateId) {
		var ret string
		return ret
	}
	return *o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDto) GetTemplateIdOk() (*string, bool) {
	if o == nil || IsNil(o.TemplateId) {
		return nil, false
	}
	return o.TemplateId, true
}

// HasTemplateId returns a boolean if a field has been set.
func (o *GoogleBigQueryDto) HasTemplateId() bool {
	if o != nil && !IsNil(o.TemplateId) {
		return true
	}

	return false
}

// SetTemplateId gets a reference to the given string and assigns it to the TemplateId field.
func (o *GoogleBigQueryDto) SetTemplateId(v string) {
	o.TemplateId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleBigQueryDto) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDto) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleBigQueryDto) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleBigQueryDto) SetLabel(v string) {
	o.Label = &v
}

// GetStrategy returns the Strategy field value if set, zero value otherwise.
func (o *GoogleBigQueryDto) GetStrategy() string {
	if o == nil || IsNil(o.Strategy) {
		var ret string
		return ret
	}
	return *o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDto) GetStrategyOk() (*string, bool) {
	if o == nil || IsNil(o.Strategy) {
		return nil, false
	}
	return o.Strategy, true
}

// HasStrategy returns a boolean if a field has been set.
func (o *GoogleBigQueryDto) HasStrategy() bool {
	if o != nil && !IsNil(o.Strategy) {
		return true
	}

	return false
}

// SetStrategy gets a reference to the given string and assigns it to the Strategy field.
func (o *GoogleBigQueryDto) SetStrategy(v string) {
	o.Strategy = &v
}

// GetRequest returns the Request field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GoogleBigQueryDto) GetRequest() HttpConnectorDtoRequest {
	if o == nil || IsNil(o.Request.Get()) {
		var ret HttpConnectorDtoRequest
		return ret
	}
	return *o.Request.Get()
}

// GetRequestOk returns a tuple with the Request field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GoogleBigQueryDto) GetRequestOk() (*HttpConnectorDtoRequest, bool) {
	if o == nil {
		return nil, false
	}
	return o.Request.Get(), o.Request.IsSet()
}

// HasRequest returns a boolean if a field has been set.
func (o *GoogleBigQueryDto) HasRequest() bool {
	if o != nil && o.Request.IsSet() {
		return true
	}

	return false
}

// SetRequest gets a reference to the given NullableHttpConnectorDtoRequest and assigns it to the Request field.
func (o *GoogleBigQueryDto) SetRequest(v HttpConnectorDtoRequest) {
	o.Request.Set(&v)
}

// SetRequestNil sets the value for Request to be an explicit nil
func (o *GoogleBigQueryDto) SetRequestNil() {
	o.Request.Set(nil)
}

// UnsetRequest ensures that no value is present for Request, not even an explicit nil
func (o *GoogleBigQueryDto) UnsetRequest() {
	o.Request.Unset()
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleBigQueryDto) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDto) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleBigQueryDto) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *GoogleBigQueryDto) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetProjectId returns the ProjectId field value if set, zero value otherwise.
func (o *GoogleBigQueryDto) GetProjectId() int32 {
	if o == nil || IsNil(o.ProjectId) {
		var ret int32
		return ret
	}
	return *o.ProjectId
}

// GetProjectIdOk returns a tuple with the ProjectId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDto) GetProjectIdOk() (*int32, bool) {
	if o == nil || IsNil(o.ProjectId) {
		return nil, false
	}
	return o.ProjectId, true
}

// HasProjectId returns a boolean if a field has been set.
func (o *GoogleBigQueryDto) HasProjectId() bool {
	if o != nil && !IsNil(o.ProjectId) {
		return true
	}

	return false
}

// SetProjectId gets a reference to the given int32 and assigns it to the ProjectId field.
func (o *GoogleBigQueryDto) SetProjectId(v int32) {
	o.ProjectId = &v
}

// GetDatasetId returns the DatasetId field value if set, zero value otherwise.
func (o *GoogleBigQueryDto) GetDatasetId() string {
	if o == nil || IsNil(o.DatasetId) {
		var ret string
		return ret
	}
	return *o.DatasetId
}

// GetDatasetIdOk returns a tuple with the DatasetId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDto) GetDatasetIdOk() (*string, bool) {
	if o == nil || IsNil(o.DatasetId) {
		return nil, false
	}
	return o.DatasetId, true
}

// HasDatasetId returns a boolean if a field has been set.
func (o *GoogleBigQueryDto) HasDatasetId() bool {
	if o != nil && !IsNil(o.DatasetId) {
		return true
	}

	return false
}

// SetDatasetId gets a reference to the given string and assigns it to the DatasetId field.
func (o *GoogleBigQueryDto) SetDatasetId(v string) {
	o.DatasetId = &v
}

// GetTableId returns the TableId field value if set, zero value otherwise.
func (o *GoogleBigQueryDto) GetTableId() string {
	if o == nil || IsNil(o.TableId) {
		var ret string
		return ret
	}
	return *o.TableId
}

// GetTableIdOk returns a tuple with the TableId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDto) GetTableIdOk() (*string, bool) {
	if o == nil || IsNil(o.TableId) {
		return nil, false
	}
	return o.TableId, true
}

// HasTableId returns a boolean if a field has been set.
func (o *GoogleBigQueryDto) HasTableId() bool {
	if o != nil && !IsNil(o.TableId) {
		return true
	}

	return false
}

// SetTableId gets a reference to the given string and assigns it to the TableId field.
func (o *GoogleBigQueryDto) SetTableId(v string) {
	o.TableId = &v
}

// GetStatement returns the Statement field value if set, zero value otherwise.
func (o *GoogleBigQueryDto) GetStatement() string {
	if o == nil || IsNil(o.Statement) {
		var ret string
		return ret
	}
	return *o.Statement
}

// GetStatementOk returns a tuple with the Statement field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDto) GetStatementOk() (*string, bool) {
	if o == nil || IsNil(o.Statement) {
		return nil, false
	}
	return o.Statement, true
}

// HasStatement returns a boolean if a field has been set.
func (o *GoogleBigQueryDto) HasStatement() bool {
	if o != nil && !IsNil(o.Statement) {
		return true
	}

	return false
}

// SetStatement gets a reference to the given string and assigns it to the Statement field.
func (o *GoogleBigQueryDto) SetStatement(v string) {
	o.Statement = &v
}

func (o GoogleBigQueryDto) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleBigQueryDto) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ConnectorId) {
		toSerialize["connectorId"] = o.ConnectorId
	}
	if !IsNil(o.TemplateId) {
		toSerialize["templateId"] = o.TemplateId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Strategy) {
		toSerialize["strategy"] = o.Strategy
	}
	if o.Request.IsSet() {
		toSerialize["request"] = o.Request.Get()
	}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.ProjectId) {
		toSerialize["projectId"] = o.ProjectId
	}
	if !IsNil(o.DatasetId) {
		toSerialize["datasetId"] = o.DatasetId
	}
	if !IsNil(o.TableId) {
		toSerialize["tableId"] = o.TableId
	}
	if !IsNil(o.Statement) {
		toSerialize["statement"] = o.Statement
	}
	return toSerialize, nil
}

type NullableGoogleBigQueryDto struct {
	value *GoogleBigQueryDto
	isSet bool
}

func (v NullableGoogleBigQueryDto) Get() *GoogleBigQueryDto {
	return v.value
}

func (v *NullableGoogleBigQueryDto) Set(val *GoogleBigQueryDto) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleBigQueryDto) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleBigQueryDto) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleBigQueryDto(val *GoogleBigQueryDto) *NullableGoogleBigQueryDto {
	return &NullableGoogleBigQueryDto{value: val, isSet: true}
}

func (v NullableGoogleBigQueryDto) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleBigQueryDto) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
